/*
    Génération de feuille de personnage complète AD&D 1 et 2
    Génération aléatoire de personnage

    Copyright (C) 2011 Bernard SIAUD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "include.h"

void version(GtkRadioAction *action, GtkRadioAction *current, gpointer param) /*( gpointer param,guint callback_action,GtkWidget *menu_item ) */
{
    gchar race=donne_race(((struct_race **)param)[MAIN_RACE],((unsigned short **)param)[MAIN_NB_RACE][0]);
    char version_dd=gtk_radio_action_get_current_value (current);


    /*if (version_dd!=ADD1)
    {
        if (race==DEMI_ORC)
        {
            valide("humain",param);
        }
        inactive("demi_orc",*((GtkActionGroup **)param+3));
    }
    else
    {
        active("demi_orc",*((GtkActionGroup **)param+3));
    }
    if (version_dd==DD)
    {
        if (race==DEMI_ELFE)
        {
            valide("humain",param);
        }
        inactive("demi_elfe",*((GtkActionGroup **)param+3));
    }
    else
    {
        active("demi_elfe",*((GtkActionGroup **)param+3));
    }*/

    race_classe(race,version_dd,param);

    (void) action;
}


void print_race(GtkRadioAction *action,gpointer param) /*( gpointer param,guint callback_action,GtkWidget *menu_item ) */
{
    unsigned short race=donne_race(((struct_race **)param)[MAIN_RACE],((unsigned short **)param)[MAIN_NB_RACE][0]);
    unsigned short version_=trouve_version(gtk_action_group_list_actions (*((GtkActionGroup **)param+ MAIN_GR_ACTION)));

    race_classe(race,version_,param);

    (void) action;
}

void print_force(GtkRadioAction *action, GtkRadioAction *current, gpointer param) /*( gpointer param,guint callback_action,GtkWidget *menu_item ) */
{
   inverse(FORCE,gtk_radio_action_get_current_value (current),param);
   (void)action;
}

void print_intelligence(GtkRadioAction *action, GtkRadioAction *current, gpointer param) /*( gpointer param,guint callback_action,GtkWidget *menu_item ) */
{
   inverse(INTELLIGENCE,gtk_radio_action_get_current_value (current),param);
   (void)action;
}

void print_sagesse(GtkRadioAction *action, GtkRadioAction *current, gpointer param) /*( gpointer param,guint callback_action,GtkWidget *menu_item ) */
{
   inverse(SAGESSE,gtk_radio_action_get_current_value (current),param);
   (void)action;
}

void print_dexterite(GtkRadioAction *action, GtkRadioAction *current, gpointer param) /*( gpointer param,guint callback_action,GtkWidget *menu_item ) */
{
   inverse(DEXTERITE,gtk_radio_action_get_current_value (current),param);
   (void)action;
}

void print_constitution(GtkRadioAction *action, GtkRadioAction *current, gpointer param) /*( gpointer param,guint callback_action,GtkWidget *menu_item ) */
{
   inverse(CONSTITUTION,gtk_radio_action_get_current_value (current),param);
   (void)action;
}

void print_charisme(GtkRadioAction *action, GtkRadioAction *current, gpointer param) /*( gpointer param,guint callback_action,GtkWidget *menu_item ) */
{
   inverse(CHARISME,gtk_radio_action_get_current_value (current),param);
   (void)action;
}

void print_beaute(GtkRadioAction *action, GtkRadioAction *current, gpointer param) /*( gpointer param,guint callback_action,GtkWidget *menu_item ) */
{
   unsigned short t=gtk_radio_action_get_current_value (current);
   unsigned short * val=*((unsigned short **)param+1);


   if (t!=9 || val[BEAUTE]!=9) /* éviter le cas les 2 = */
   {if (t!=9 && val[BEAUTE]!=9)
      inverse(BEAUTE,t,param);
   else
    if (t!=9)
    { /* avant on avait 9 */
        humour_beaute(*((GtkActionGroup **)param+3));
        val[BEAUTE]=7;
        val[HUMOUR]=8;
        inverse(BEAUTE,t,param);
    }
    else
    {
        inverse(BEAUTE,7,param);
        inverse(HUMOUR,8,param);
        val[BEAUTE]=9;
        val[HUMOUR]=9;
        non_humour_beaute(*((GtkActionGroup **)param+3));

    }}
   (void)action;
}

void print_humour(GtkRadioAction *action, GtkRadioAction *current, gpointer param) /*( gpointer param,guint callback_action,GtkWidget *menu_item ) */
{
   unsigned short t=gtk_radio_action_get_current_value (current);
   unsigned short * val=*((unsigned short **)param+1);


   if (t!=9 || val[HUMOUR]!=9) /* éviter le cas les 2 = */
   {if (t!=9 && val[HUMOUR]!=9)
      inverse(HUMOUR,t,param);
   else
    if (t!=9)
    { /* avant on avait 9 */
        humour_beaute(*((GtkActionGroup **)param+3));
        val[HUMOUR]=7;
        val[BEAUTE]=8;
        inverse(BEAUTE,t,param);
    }
    else
    {
        inverse(HUMOUR,7,param);
        inverse(BEAUTE,8,param);
        val[BEAUTE]=9;
        val[HUMOUR]=9;
        non_humour_beaute(*((GtkActionGroup **)param+3));
    }}
   (void)action;
}

