/*
    Génération de feuille de personnage complète AD&D 1 et 2
    Génération aléatoire de personnage

    Copyright (C) 2011 Bernard SIAUD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <string.h>
#include "include.h"

void affiche_sort_mag(unsigned short niveau,gpointer param,GMarkupDomNode * ooo)
{ /* niveau actuel, pointeur général , node fichier */
    unsigned short i,j,k,l,m,ecole=0,e[12];
    GMarkupDomNode * node=nv_tableau_sort(ooo,niveau+1,"mago");
    liste_classe * l_c;
    struct_classe * s_c;

    for (j=0;j<((unsigned short **)param)[NB_SORT_MAG_NIV][niveau];j++)
    {
        if (((unsigned char ***)param)[SORT_MAG_MAIT][niveau][j]!=0) /* si le sort est présent dans le livre */
        {
            ecole=0;
            for(i=0;i<NB_SORT_MAG;i++)
            {
                if (strcmp(sortileges_mag[i].nom,((char ****)param)[SORT_MAG][niveau][j])==0)
                {
                    for (k=0,l_c=((liste_classe **)param)[METIER];l_c!=NULL;l_c=l_c->suiv,k++)
                    { /* parcours des classes */
                        for(l=0;l<12;l++) e[l]=0;
                        s_c=trouve_classe(l_c->nom,((struct_classe***)param)[MENU][MAIN_CLASSE]);
                        if (s_c->add2.nom!=NULL)
                        {
                            if ((sortileges_mag+i)->sphere&(1<<9)) /* cas des sorts entropiques */
                            {
                                        for(m=0;s_c->add2.sort_mago_ecole[m]!=NULL;m++)
                                            e[9]+=(compare_sans_casse(ecole_mag[9],s_c->add2.sort_mago_ecole[m])==0);
                            }
                            else for(l=0;l<12;l++)
                                if ((sortileges_mag+i)->sphere&(1<<l))
                                {
                                        for(m=0;s_c->add2.sort_mago_ecole[m]!=NULL;m++)
                                            e[l]+=(compare_sans_casse(ecole_mag[l],s_c->add2.sort_mago_ecole[m])==0);
                                }
                        }
                        for(l=0;l<12;l++)
                            ecole=max(ecole,e[l]);
                    }

                     if (ecole==0)
                      insere_ligne_pretre(node,sortileges_mag+i,4);
                     else if ((unsigned short)((unsigned char ***)param)[SORT_MAG_MAIT][niveau][j]==1 && ecole==2) /* 1 => lu, 2 => Pas compris, 3 pas lu */
                      insere_ligne_pretre(node,sortileges_mag+i,5);
                     else
                      insere_ligne_pretre(node,sortileges_mag+i,(unsigned short)((unsigned char ***)param)[SORT_MAG_MAIT][niveau][j]);
                     i=NB_SORT_MAG; /* sortie de la boucle */
                }
            }
        }
    }
}

void init_mag(GtkWidget *wid, gpointer param)
{
  unsigned short i,j;

  for(i=0;i<9;i++)
  {
      for (j=0;j<((unsigned short **)param)[M_NB_SORT_MAG][i];j++)
          gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget *****)param)[M_SORT_MAG][i][j][0]),TRUE);
  }

  (void)wid;
}
