/*
    Génération de feuille de personnage complète AD&D 1 et 2
    Génération aléatoire de personnage

    Copyright (C) 2011 Bernard SIAUD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdlib.h>
#include <string.h>
#include "include.h"

gpointer modifier_caract(GtkWidget *wid, gpointer param)
{
  GtkWidget *pWindow;
  GtkWidget *pVBox,*pHBox,*pVBox1,*pVBox2,*pHBox1,* pVBox_classes, * event_classes, *pVBox11, *pVBox3, *pVBox_armes,*pVBox_comp, *event_armes, *pVBoxPDV,*pVBoxPDV3,*pVBox_PDV,*event_PDV,*pVBoxComp,*pVBoxComp3,*event_Comp, * event_, * Box_, * pHBox_armure;
  GtkWidget * Box_classe, ** xp_classe=NULL;
  GtkWidget ** entree=NULL, ** car_vol; /* à effacer en sortant */
  GtkWidget * label;
  GtkWidget * onglet_maitre, * onglet1, * onglet2;
  GtkWidget * label_onglet1, * label_onglet2;
  GtkWidget * label_pan, * label_dieu;
  GtkWidget * texte;
  GtkWidget * onglet_mag;

  GtkListStore * p_model = gtk_list_store_new (1, G_TYPE_STRING);
  GtkListStore * p_model_race = gtk_list_store_new (1, G_TYPE_STRING);
  GtkListStore * p_model_sexe = gtk_list_store_new (1, G_TYPE_STRING);
  GtkListStore * p_model_classe = gtk_list_store_new (1, G_TYPE_STRING);
  GtkListStore * p_model_armes = gtk_list_store_new (1, G_TYPE_STRING);
  GtkListStore * p_model_comp = gtk_list_store_new (1, G_TYPE_STRING);
  GtkListStore * p_model_pan = gtk_list_store_new (1, G_TYPE_STRING);
  GtkListStore * p_model_dieu = gtk_list_store_new (1, G_TYPE_STRING);
  GtkListStore * p_model_armure = gtk_list_store_new (1, G_TYPE_STRING);
  char ch[LONG],* chemin;
  GtkWidget * p_combo = gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model));
  GtkWidget * p_combo_race = gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model_race));
  GtkWidget * p_combo_sexe = gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model_sexe));
  GtkWidget ** p_combo_classe = NULL, ** niv_classe=NULL, ** pHBox_classes=NULL; /* à effacer en sortant */
  GtkWidget ** p_combo_armes = NULL, ** niv_armes=NULL, ** pHBox_armes=NULL, * label_armes, ** mag_armes;
  GtkWidget * p_combo_pantheon= gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model_pan));
  GtkWidget * p_combo_dieu= gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model_dieu));
  GtkWidget * p_combo_armure1= gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model_armure));
  GtkWidget * p_combo_armure2= gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model_armure));
  GtkWidget * pVBoxOnglets;
  GMarkupDomNode * node,*node1;
  GtkWidget ** niv_pdv = NULL;
  GtkWidget * bouton_vol1, * label_vol2;
  GtkWidget ** p_combo_comp = NULL, ** niv_comp=NULL, ** pHBox_comp=NULL, * label_compt;
  GtkWidget * table_vol, * pHBox_sort_fin, * pVBox_fin;
  GtkCellRenderer * p_cell = NULL,** p_cell_armes = NULL, * p_cell_race,* p_cell_dieu = NULL,* p_cell_armure = NULL;
  GtkTreeIter  iter;
  GtkWidget * b_valide, * b_annule, * b_initialise, *b_moins, *b_plus,* b_plus_a,*b_moins_a,*b_moins_c,*b_moins_pdv,* b_plus_c,* b_plus_pdv;
  unsigned short * caract=((unsigned short **)param)[CARACT],
                 * nb_case_metier=(unsigned short *)malloc(2*sizeof(unsigned short)),
                 * nb_case_pdv=(unsigned short *)malloc(2*sizeof(unsigned short)),
                 * nb_case_comp=(unsigned short *)malloc(2*sizeof(unsigned short)),
                 * nb_case_armes=(unsigned short *)malloc(2*sizeof(unsigned short)); /* dernier élément à supprimer */
  unsigned short i,j,k;
  gpointer * tparam;
  GdkColor color;
  GtkWidget **** sort_mag;
  unsigned short * nb_sort_mag;

  GtkWidget ** d_taille, ** d_poids;
  GtkWidget * dv_taille, * dv_poids;
  GtkWidget * c_taille, * c_poids;
  GtkWidget * label_taille, * d_taille_race;
  GtkWidget * nom_perso, * nom_joueur, * classe_sociale, * couleur_peau, * couleur_cheveux, *couleur_yeux, *age;
  GtkWidget * bouclier, * bonus_AC , * mag_armure1, *mag_armure2, *mag_bouclier;
  GtkWidget ** alignement;
  unsigned short * m_modif=(unsigned short *)malloc(sizeof(unsigned short));
  GtkTextBuffer *p_text_buffer = NULL;
  liste_classe * l_c;
  //struct_race  * s_r;
  GError * error;
  unsigned short nb_metier=0;

  for (l_c=((liste_classe **)param)[METIER];l_c!=NULL;l_c=l_c->suiv)
    nb_metier++;

  *m_modif=0;

  if (((gpointer*)param)[FILS])
  {
      gtk_window_present (GTK_WINDOW(((GtkWidget **)param)[FILS]));
      return NULL;
  }  /* si le père a déjà un fils équivalent : disparaitre */
  entree=(GtkWidget **)malloc(10*sizeof(GtkWidget *));
  tparam=(gpointer *)malloc(67*sizeof(gpointer));

  pWindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  ((gpointer*)param)[FILS]=(gpointer)pWindow;
  gtk_window_set_title(GTK_WINDOW(pWindow), "Modifications");
  g_signal_connect(G_OBJECT(pWindow), "destroy", G_CALLBACK(fin_modif_caract), tparam);
  chemin=chemin_exe();
  sprintf(ch,"%s%c3d6_ico.png",chemin,SEPARATEUR);
  free(chemin);
  if (!gtk_window_set_icon_from_file(GTK_WINDOW (pWindow),ch,&error))
  {                                                                  /* met une icone à la fenêtre                                   */
   traite_erreur(error);
   g_error_free(error);
  }


  /* niveau 1 : la fenêtre principale : une boite horizontale */
  pVBox1 = gtk_vbox_new(FALSE, 6);
  gtk_container_add(GTK_CONTAINER(pWindow), pVBox1);
  pHBox1 = gtk_hbox_new(FALSE, 6);

   /* niveau 2 : 5 boite verticales dans la boite horizontale */
   pVBox = gtk_hbox_new(FALSE, 6);
   gtk_container_add(GTK_CONTAINER(pVBox1) , pVBox);
   gtk_container_add(GTK_CONTAINER(pVBox1), pHBox1);

    /* niveau 3 de la première boite verticale : les caractéristiques */

    entree[POURCENTAGE]=gtk_spin_button_new_with_range(0, 100, 1);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(entree[POURCENTAGE]),caract[POURCENTAGE]);
    for (i=0;i<8;i++)
    {
     entree[i]=gtk_spin_button_new_with_range(0, 25, 1);
     gtk_spin_button_set_value(GTK_SPIN_BUTTON(entree[i]),caract[i]);
     label=gtk_label_new (nom[i]);
     gtk_box_pack_start (GTK_BOX (pVBox), label, TRUE, TRUE, 0);
     gtk_box_pack_start (GTK_BOX (pVBox), entree[i], FALSE, TRUE, 0);
     if (i==FORCE)
     {
           pHBox = gtk_hbox_new(FALSE, 6);
           label=gtk_label_new ("%");
           gtk_box_pack_start (GTK_BOX (pVBox), pHBox, TRUE, TRUE, 0);
           gtk_box_pack_start (GTK_BOX (pHBox), entree[POURCENTAGE], TRUE, TRUE, 0);
           gtk_box_pack_start (GTK_BOX (pHBox), label, TRUE, TRUE, 0);
     }
    }
    /* pour la force et son % */
    for (i=1;i<8;i++)
    {
    }


    g_signal_connect (G_OBJECT (entree[FORCE]),        "value_changed", G_CALLBACK (modif_force), (gpointer) tparam);
    g_signal_connect (G_OBJECT (entree[SAGESSE]),      "value_changed", G_CALLBACK (modif_sagesse), (gpointer) tparam);
    g_signal_connect (G_OBJECT (entree[INTELLIGENCE]), "value_changed", G_CALLBACK (modif_intelligence), (gpointer) tparam);
    g_signal_connect (G_OBJECT (entree[DEXTERITE]),    "value_changed", G_CALLBACK (modif_dexterite), (gpointer) tparam);
    g_signal_connect (G_OBJECT (entree[CONSTITUTION]), "value_changed", G_CALLBACK (modif_constitution), (gpointer) tparam);
    g_signal_connect (G_OBJECT (entree[CHARISME]),     "value_changed", G_CALLBACK (modif_charisme), (gpointer) tparam);
    g_signal_connect (G_OBJECT (entree[HUMOUR]),       "value_changed", G_CALLBACK (modif_c), (gpointer) tparam);
    g_signal_connect (G_OBJECT (entree[BEAUTE]),       "value_changed", G_CALLBACK (modif_c), (gpointer) tparam);
    g_signal_connect (G_OBJECT (entree[POURCENTAGE]),  "value_changed", G_CALLBACK (modif_c), (gpointer) tparam);


   /* Niveau 2 de la seconde colonne */
   pVBox1 = gtk_vbox_new(FALSE, 6);
   gtk_container_add(GTK_CONTAINER(pHBox1) , pVBox1);

    /* niveau 3 de la seconde boite : nature du personnage */
     /* niveau 4 : version de D&D */
     p_cell = gtk_cell_renderer_text_new ();
     gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (p_combo), p_cell, FALSE);
     gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (p_combo),p_cell, "text", 0,NULL);
     for(i=0;i<3;i++)
     {
      gtk_list_store_append (p_model, & iter);
      gtk_list_store_set (p_model, & iter,0, vers[i],-1);
     }
     gtk_combo_box_set_active (GTK_COMBO_BOX (p_combo), ((unsigned short **)param)[VERSION][0]);
     g_signal_connect (G_OBJECT (p_combo), "changed", G_CALLBACK (modif_classe), (gpointer) tparam);
     gtk_box_pack_start (GTK_BOX (pVBox1), p_combo, FALSE, FALSE, 0);
     /* niveau 4 : race du personnage */
     p_cell_race = gtk_cell_renderer_text_new ();
     gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (p_combo_race), p_cell_race, FALSE);
     gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (p_combo_race),p_cell_race, "text", 0,NULL);
     for (i=0;i<((unsigned short ***)param)[MENU][MAIN_NB_RACE][0];i++)
     {
         gtk_list_store_append (p_model_race, & iter);
         if (((struct_race ***)param)[MENU][MAIN_RACE][i].add1.nom!=NULL)
         {
            gtk_list_store_set (p_model_race, & iter,0, ((struct_race ***)param)[MENU][MAIN_RACE][i].add1.nom,-1);
         }
         else
         {
            gtk_list_store_set (p_model_race, & iter,0, ((struct_race ***)param)[MENU][MAIN_RACE][i].add2.nom,-1);
         }
     }
     gtk_combo_box_set_active (GTK_COMBO_BOX (p_combo_race), ((unsigned short **)param)[RACE][0]);
     g_signal_connect (G_OBJECT (p_combo_race), "changed", G_CALLBACK (modif_race), (gpointer) tparam);
     gtk_box_pack_start (GTK_BOX (pVBox1), p_combo_race, FALSE,TRUE, 0);
     /* niveau 4 : sexe du personnage */
     p_cell = gtk_cell_renderer_text_new ();
     gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (p_combo_sexe), p_cell, FALSE);
     gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (p_combo_sexe),p_cell, "text", 0,NULL);
     for(i=0;i<2;i++)
     {
      gtk_list_store_append (p_model_sexe, & iter);
      gtk_list_store_set (p_model_sexe, & iter,0, nom_sexe(i),-1);
     }
     gtk_combo_box_set_active (GTK_COMBO_BOX (p_combo_sexe), ((unsigned short **)param)[SEXE][0]);
     g_signal_connect (G_OBJECT (p_combo_sexe), "changed", G_CALLBACK (modif_taille), (gpointer) tparam);
     gtk_box_pack_start (GTK_BOX (pVBox1), p_combo_sexe, FALSE,FALSE, 0); /* F/T hauteur réservée pour le bouton , hauteur prise par le bouton */

     /* niveau 4 : donner la ou les classes du personnage */
      pVBox_classes = gtk_vbox_new(FALSE, 6);
      pVBox2 = gtk_vbox_new(FALSE, 6);
       /* le bouton - du début */
       b_moins = gtk_button_new_from_stock (GTK_STOCK_REMOVE);
       g_signal_connect (G_OBJECT (b_moins), "clicked", G_CALLBACK (moins_c), (gpointer) tparam);
       gtk_box_pack_start (GTK_BOX (pVBox2), b_moins, FALSE, FALSE, 1);
       /* les boutons du milieu */
       gtk_box_pack_start (GTK_BOX (pVBox2), pVBox_classes, TRUE,FALSE, 0); /* option true pour prendre toute la place */
        /* Création des boutons métiers dans pVBox_classes */
        *nb_case_metier=nb_metier;   /* nb actuel  */
        nb_case_metier[1]=nb_metier; /*max atteind */
        p_combo_classe=(GtkWidget **)malloc(*nb_case_metier*sizeof(GtkWidget *));
        niv_classe=(GtkWidget **)malloc(*nb_case_metier*sizeof(GtkWidget *));
        xp_classe=(GtkWidget **)malloc(*nb_case_metier*sizeof(GtkWidget *));
        pHBox_classes=(GtkWidget **)malloc(*nb_case_metier*sizeof(GtkWidget *));
        p_cell = gtk_cell_renderer_text_new ();
        for (i=0;i<((unsigned short ***)param)[MENU][MAIN_NB_CLASSE][0];i++)
        {
         gtk_list_store_append (p_model_classe, & iter);
         if (((struct_classe ***)param)[MENU][MAIN_CLASSE][i].add1.nom!=NULL)
            gtk_list_store_set (p_model_classe, & iter,0, ((struct_classe ***)param)[MENU][MAIN_CLASSE][i].add1.nom,-1);
         else
            gtk_list_store_set (p_model_classe, & iter,0, ((struct_classe ***)param)[MENU][MAIN_CLASSE][i].add2.nom,-1);
        }
        for(l_c=((liste_classe **)param)[METIER],i=0;i<nb_metier;i++,l_c=l_c->suiv)
        {
            /* un bouton est constitué d'une case horizontale avec deux items */
            pHBox_classes[i] = gtk_hbox_new(FALSE, 6); /* FALSE : limite la taille des boutons */
            gtk_box_pack_start (GTK_BOX (pVBox_classes), pHBox_classes[i], TRUE,TRUE, 0);
             /* un combo avec la liste des classes */
             p_combo_classe[i]=gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model_classe));
             gtk_box_pack_start (GTK_BOX (pHBox_classes[i]), p_combo_classe[i], TRUE,TRUE, 0);
             /* un spin pour donner le niveau */
             niv_classe[i]=gtk_spin_button_new_with_range(0, 99, 1);
             gtk_spin_button_set_value(GTK_SPIN_BUTTON(niv_classe[i]),l_c->niveau); /* initiation du spin */
             gtk_box_pack_start (GTK_BOX (pHBox_classes[i]), niv_classe[i], TRUE,TRUE, 0);
             xp_classe[i]=gtk_spin_button_new_with_range(0,99999999,1);
             gtk_spin_button_set_value(GTK_SPIN_BUTTON(xp_classe[i]),l_c->xp); /* initiation du spin */
             gtk_box_pack_start (GTK_BOX (pHBox_classes[i]), xp_classe[i], TRUE,TRUE, 0);
             g_signal_connect (G_OBJECT (xp_classe[i]), "value_changed", G_CALLBACK (modif_classe),(gpointer) tparam);
            gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (p_combo_classe[i]), p_cell, FALSE);
            gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (p_combo_classe[i]),p_cell, "text", 0,NULL);
            gtk_combo_box_set_active (GTK_COMBO_BOX (p_combo_classe[i]),trouve_num_metier(l_c->nom,((gpointer *)param)[MENU]));
            g_signal_connect (G_OBJECT (p_combo_classe[i]), "changed", G_CALLBACK (modif_classe), (gpointer) tparam);
            g_signal_connect (G_OBJECT (niv_classe[i]), "value_changed", G_CALLBACK (modif_classe), (gpointer) tparam);
        }
       /* le bouton + de la fin */
       b_plus = gtk_button_new_from_stock (GTK_STOCK_ADD);
       g_signal_connect (G_OBJECT (b_plus), "clicked", G_CALLBACK (plus_c), (gpointer) tparam);
       gtk_box_pack_start (GTK_BOX (pVBox2), b_plus, FALSE, FALSE, 1);
     Box_classe= gtk_frame_new("Classe / niveau / points d'expérience");
     event_classes= gtk_event_box_new();
     color.pixel = 32;
     color.red = 60000;
     color.green = 65000;
     color.blue = 65000;
     gtk_widget_modify_bg (event_classes, GTK_STATE_NORMAL, &color);
     gtk_container_add (GTK_CONTAINER (event_classes), Box_classe);
     gtk_container_add (GTK_CONTAINER (Box_classe), pVBox2);
    gtk_box_pack_start (GTK_BOX (pVBox1), event_classes, TRUE,TRUE, 0);

    /* onglets + boutons en bas */
    pVBoxOnglets = gtk_vbox_new(FALSE, 6);
    gtk_box_pack_start(GTK_BOX(pHBox1), pVBoxOnglets, TRUE, TRUE, 0);
    onglet_maitre=gtk_notebook_new();
    gtk_box_pack_start(GTK_BOX(pVBoxOnglets), onglet_maitre, TRUE, TRUE, 0);

    /* Position des onglets : en bas */
    gtk_notebook_set_tab_pos(GTK_NOTEBOOK(onglet_maitre), GTK_POS_BOTTOM);
    /* Ajout des boutons de navigation */
    gtk_notebook_set_scrollable(GTK_NOTEBOOK(onglet_maitre), TRUE);
     /* le premier onglet */
     onglet1=gtk_hbox_new(FALSE, 6);
     label_onglet1=gtk_label_new("PDV-Compétences");
     gtk_notebook_append_page(GTK_NOTEBOOK(onglet_maitre), onglet1, label_onglet1);

       /* troisième colonne : les PDV */
       pVBoxPDV = gtk_vbox_new(FALSE, 6);
       gtk_container_add(GTK_CONTAINER(onglet1) , pVBoxPDV);
        /* on va mettre une boite verticale de couleur dans la colonne des PDV */
        event_PDV= gtk_event_box_new();
        gtk_box_pack_start (GTK_BOX (pVBoxPDV), event_PDV, TRUE,TRUE, 0);
         color.pixel = 32;
         color.red = 60000;
         color.green =50000;
         color.blue = 10000;
         gtk_widget_modify_bg (event_PDV, GTK_STATE_NORMAL, &color);
         pVBoxPDV3 = gtk_vbox_new(FALSE, 6);
         gtk_container_add (GTK_CONTAINER (event_PDV), pVBoxPDV3);
          label=gtk_label_new ("PDV\npar\nniveau"); /* adjonction d'un label à cette colonne car elle ne contient que des nombres seuls, ce qui est peu explicite */
          gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_CENTER); /* centrer la ligne */
          gtk_box_pack_start (GTK_BOX (pVBoxPDV3), label, FALSE, FALSE, 1);
          b_moins_pdv = gtk_button_new_from_stock (GTK_STOCK_DELETE);
          gtk_button_set_label (GTK_BUTTON(b_moins_pdv),"-");
          g_signal_connect (G_OBJECT (b_moins_pdv), "clicked", G_CALLBACK (moins_c_pdv), (gpointer) tparam);
          gtk_box_pack_start (GTK_BOX (pVBoxPDV3), b_moins_pdv, FALSE, FALSE, 1);

           pVBox_PDV = gtk_vbox_new(FALSE, 6);
           gtk_box_pack_start (GTK_BOX (pVBoxPDV3), pVBox_PDV, TRUE,FALSE, 0);

           *nb_case_pdv=((unsigned short **)param)[NB_PDV][0];
           nb_case_pdv[1]=*nb_case_pdv;
           niv_pdv=(GtkWidget **)malloc(*nb_case_pdv*sizeof(GtkWidget *));
           for(i=0;i<*nb_case_pdv;i++)
           {
               niv_pdv[i]=gtk_spin_button_new_with_range(0, 99, 1);
               gtk_spin_button_set_value(GTK_SPIN_BUTTON(niv_pdv[i]),((unsigned short **)param)[PDV][i]);
               gtk_box_pack_start (GTK_BOX (pVBox_PDV), niv_pdv[i], TRUE,TRUE, 0);
               g_signal_connect (G_OBJECT (niv_pdv[i]), "value_changed", G_CALLBACK (verif_pdv), (gpointer) tparam);
           }
          b_plus_pdv= gtk_button_new_from_stock (GTK_STOCK_ADD);
          gtk_button_set_label (GTK_BUTTON(b_plus_pdv),"+");
          g_signal_connect (G_OBJECT (b_plus_pdv), "clicked", G_CALLBACK (plus_c_pdv), (gpointer) tparam);
          gtk_box_pack_start (GTK_BOX (pVBoxPDV3), b_plus_pdv, FALSE, FALSE, 1);

       /* 4ème colonne, pour les comptétences */
       pVBoxComp = gtk_vbox_new(FALSE, 6);
       gtk_container_add(GTK_CONTAINER(onglet1) , pVBoxComp);
        /* La couleur à la boite */
        event_Comp= gtk_event_box_new();
        gtk_box_pack_start (GTK_BOX (pVBoxComp), event_Comp, TRUE,TRUE, 0);
        Box_classe= gtk_frame_new("Compétance / Niveau");
         color.pixel = 32;
         color.red = 45000;
         color.green = 45000;
         color.blue = 60000;
         gtk_widget_modify_bg (event_Comp, GTK_STATE_NORMAL, &color);
         /* une boite dans la couleur */
          pVBoxComp3 = gtk_vbox_new(FALSE, 6);
          gtk_container_add (GTK_CONTAINER (event_Comp), Box_classe);
          gtk_container_add (GTK_CONTAINER (Box_classe), pVBoxComp3);
          /* les items de la boite */
           b_moins_c = gtk_button_new_from_stock (GTK_STOCK_REMOVE);
           g_signal_connect (G_OBJECT (b_moins_c), "clicked", G_CALLBACK (moins_c_c), (gpointer) tparam);
           gtk_box_pack_start (GTK_BOX (pVBoxComp3), b_moins_c, FALSE, FALSE, 1);
           /* la boite qui prend toute la place pour les menu déroulants */
           pVBox_comp = gtk_vbox_new(FALSE, 6);
           gtk_box_pack_start (GTK_BOX (pVBoxComp3), pVBox_comp, TRUE,FALSE, 0);

           *nb_case_comp=((unsigned short **)param)[NB_COMP][0];
           nb_case_comp[1]=*nb_case_comp;
           p_combo_comp=(GtkWidget **)malloc(*nb_case_comp*sizeof(GtkWidget *));
           niv_comp=(GtkWidget **)malloc(*nb_case_comp*sizeof(GtkWidget *));
           pHBox_comp=(GtkWidget **)malloc(*nb_case_comp*sizeof(GtkWidget *));
           p_cell = gtk_cell_renderer_text_new ();
           for(i=0;i<MAX_COMPETENCE;i++) /* doit être avant pour choisir l'attribut */
           {
                gtk_list_store_append (p_model_comp, & iter);
                gtk_list_store_set (p_model_comp, & iter,0, competences[i].nom,-1);
           }
           for(i=0;i<*nb_case_comp;i++)
           {
               niv_comp[i]=gtk_spin_button_new_with_range(1, 99, 1);
               gtk_spin_button_set_value(GTK_SPIN_BUTTON(niv_comp[i]),((unsigned short **)param)[NV_COMP][i]);
               p_combo_comp[i]=gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model_comp));
               pHBox_comp[i] = gtk_hbox_new(FALSE, 6); /* FALSE : limite la taille des boutons */
               gtk_box_pack_start (GTK_BOX (pVBox_comp), pHBox_comp[i], TRUE,TRUE, 0);
               gtk_box_pack_start (GTK_BOX (pHBox_comp[i]), p_combo_comp[i], TRUE,TRUE, 0);
               gtk_box_pack_start (GTK_BOX (pHBox_comp[i]), niv_comp[i], TRUE,TRUE, 0);
               gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (p_combo_comp[i]), p_cell, FALSE);
               gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (p_combo_comp[i]),p_cell, "text", 0,NULL);
               gtk_combo_box_set_active (GTK_COMBO_BOX (p_combo_comp[i]),((unsigned short **)param)[COMP][i]);
               g_signal_connect (G_OBJECT (niv_comp[i]), "value_changed", G_CALLBACK (verif_compt), (gpointer) tparam);
               g_signal_connect (G_OBJECT (p_combo_comp[i]), "changed", G_CALLBACK (verif_compt), (gpointer) tparam);
           }
           b_plus_c = gtk_button_new_from_stock (GTK_STOCK_ADD);
           g_signal_connect (G_OBJECT (b_plus_c), "clicked", G_CALLBACK (plus_c_c), (gpointer) tparam);
           gtk_box_pack_start (GTK_BOX (pVBoxComp3), b_plus_c, FALSE, FALSE, 1);
           label_compt=gtk_label_new ("Compétances");
           gtk_label_set_justify(GTK_LABEL(label_compt),GTK_JUSTIFY_CENTER); /* centrer la ligne */
           gtk_box_pack_start (GTK_BOX (pVBoxComp3), label_compt, FALSE, FALSE, 1);

       /* les armes */
       pVBox11 = gtk_vbox_new(FALSE, 6);
       gtk_container_add(GTK_CONTAINER(onglet1) , pVBox11);
        /* le choix des armes */
        event_armes= gtk_event_box_new();
        gtk_box_pack_start (GTK_BOX (pVBox11), event_armes, TRUE,TRUE, 0);
         /* la couleur des armes */
         Box_classe= gtk_frame_new("Arme / Spécialisation / Magie");
         color.pixel = 32;
         color.red = 40000;
         color.green = 55000;
         color.blue = 50000;
         gtk_widget_modify_bg (event_armes, GTK_STATE_NORMAL, &color);
         pVBox3 = gtk_vbox_new(FALSE, 6);
         gtk_container_add (GTK_CONTAINER (event_armes), Box_classe);
         gtk_container_add (GTK_CONTAINER (Box_classe), pVBox3);
          b_moins_a = gtk_button_new_from_stock (GTK_STOCK_REMOVE);
          g_signal_connect (G_OBJECT (b_moins_a), "clicked", G_CALLBACK (moins_c_a), (gpointer) tparam);
          gtk_box_pack_start (GTK_BOX (pVBox3), b_moins_a, FALSE, FALSE, 1);
          pVBox_armes = gtk_vbox_new(FALSE, 6);
          gtk_box_pack_start (GTK_BOX (pVBox3), pVBox_armes, TRUE,FALSE, 0);
           *nb_case_armes=((unsigned short **)param)[NB_ARMES][0];
           nb_case_armes[1]=*nb_case_armes;
           p_combo_armes=(GtkWidget **)malloc(*nb_case_armes*sizeof(GtkWidget *));
           niv_armes=(GtkWidget **)malloc(*nb_case_armes*sizeof(GtkWidget *));
           mag_armes=(GtkWidget **)malloc(*nb_case_armes*sizeof(GtkWidget *));
           pHBox_armes=(GtkWidget **)malloc(*nb_case_armes*sizeof(GtkWidget *));
           p_cell_armes=(GtkCellRenderer **)malloc(*nb_case_armes*sizeof(GtkCellRenderer *));
           for(i=0;i<MAX_ARMES;i++)
           {
                gtk_list_store_append (p_model_armes, & iter);
                gtk_list_store_set (p_model_armes, & iter,0, armes[i].nom,-1);
           }
           for(i=0;i<*nb_case_armes;i++)
           {
               p_cell_armes[i] = gtk_cell_renderer_text_new ();
               niv_armes[i]=gtk_spin_button_new_with_range(0, 3, 1);
               gtk_spin_button_set_value(GTK_SPIN_BUTTON(niv_armes[i]),((unsigned short **)param)[NV_ARMES][i]);
               mag_armes[i]=gtk_spin_button_new_with_range(-5, 5, 1);
               gtk_spin_button_set_value(GTK_SPIN_BUTTON(mag_armes[i]),((unsigned short **)param)[MAG_ARMES][i]);
               p_combo_armes[i]=gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model_armes));
               pHBox_armes[i] = gtk_hbox_new(FALSE, 6); /* FALSE : limite la taille des boutons */
               gtk_box_pack_start (GTK_BOX (pVBox_armes), pHBox_armes[i], TRUE,TRUE, 0);
               gtk_box_pack_start (GTK_BOX (pHBox_armes[i]), p_combo_armes[i], TRUE,TRUE, 0);
               gtk_box_pack_start (GTK_BOX (pHBox_armes[i]), niv_armes[i], TRUE,TRUE, 0);
               gtk_box_pack_start (GTK_BOX (pHBox_armes[i]), mag_armes[i], TRUE,TRUE, 0);
               gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (p_combo_armes[i]), p_cell_armes[i], FALSE);
               gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (p_combo_armes[i]),p_cell_armes[i], "text", 0,NULL);
               gtk_combo_box_set_active (GTK_COMBO_BOX (p_combo_armes[i]),((unsigned short **)param)[ARMES][i]);
               g_signal_connect (G_OBJECT (niv_armes[i]), "value_changed", G_CALLBACK (verif_armes), (gpointer) tparam);
               g_signal_connect (G_OBJECT (p_combo_armes[i]), "changed", G_CALLBACK (verif_armes), (gpointer) tparam);
           }
           b_plus_a = gtk_button_new_from_stock (GTK_STOCK_ADD);
           g_signal_connect (G_OBJECT (b_plus_a), "clicked", G_CALLBACK (plus_c_a), (gpointer) tparam);
           gtk_box_pack_start (GTK_BOX (pVBox3), b_plus_a, FALSE, FALSE, 1);
           label_armes=gtk_label_new ("Compétances Martiales");
           gtk_label_set_justify(GTK_LABEL(label_armes),GTK_JUSTIFY_CENTER); /* centrer la ligne */
           gtk_box_pack_start (GTK_BOX (pVBox3), label_armes, FALSE, FALSE, 1);


     /* le second onglet */
     onglet1=gtk_hbox_new(FALSE, 6);
     label_onglet2=gtk_label_new("Voleur-Dieu-Armure-Divers");
     gtk_notebook_append_page(GTK_NOTEBOOK(onglet_maitre), onglet1, label_onglet2);


       pHBox=gtk_vbox_new(FALSE, 6);
       gtk_box_pack_start (GTK_BOX (onglet1), pHBox, TRUE, TRUE, 1);
       pVBox= gtk_vbox_new(FALSE, 6);
       gtk_box_pack_start (GTK_BOX (pHBox),pVBox, TRUE, TRUE, 1);

       Box_= gtk_frame_new("Nom du Personnage");
       event_= gtk_event_box_new();
       color.pixel = 32;
       color.red = 60000;
       color.green = 55000;
       color.blue = 40000;
       gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
       gtk_container_add (GTK_CONTAINER (event_), Box_);
       gtk_box_pack_start (GTK_BOX (pVBox), event_, TRUE,TRUE, 0);
       nom_perso=gtk_entry_new();
       gtk_container_add (GTK_CONTAINER (Box_), nom_perso);
       g_signal_connect (G_OBJECT (nom_perso),        "changed", G_CALLBACK (modif_c), (gpointer) tparam);

       Box_= gtk_frame_new("Nom du Joueur");
       event_= gtk_event_box_new();
       color.pixel = 32;
       color.red = 60000;
       color.green = 55000;
       color.blue = 40000;
       gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
       gtk_container_add (GTK_CONTAINER (event_), Box_);
       gtk_box_pack_start (GTK_BOX (pVBox), event_, TRUE,TRUE, 0);
       nom_joueur=gtk_entry_new();
       gtk_container_add (GTK_CONTAINER (Box_), nom_joueur);
       g_signal_connect (G_OBJECT (nom_joueur),        "changed", G_CALLBACK (modif_c), (gpointer) tparam);

       Box_= gtk_frame_new("Age du personnage");
       event_= gtk_event_box_new();
       color.pixel = 32;
       color.red = 50000;
       color.green = 55000;
       color.blue = 40000;
       gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
       gtk_container_add (GTK_CONTAINER (event_), Box_);
       gtk_box_pack_start (GTK_BOX (pVBox), event_, TRUE,TRUE, 0);
       age=gtk_entry_new();
       gtk_container_add (GTK_CONTAINER (Box_), age);
       g_signal_connect (G_OBJECT (age),        "changed", G_CALLBACK (modif_c), (gpointer) tparam);


       Box_= gtk_frame_new("Couleur cheveux");
       event_= gtk_event_box_new();
       color.pixel = 32;
       color.red = 55000;
       color.green = 55000;
       color.blue = 40000;
       gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
       gtk_container_add (GTK_CONTAINER (event_), Box_);
       gtk_box_pack_start (GTK_BOX (pVBox), event_, TRUE,TRUE, 0);
       couleur_cheveux=gtk_entry_new();
       gtk_container_add (GTK_CONTAINER (Box_), couleur_cheveux);
       g_signal_connect (G_OBJECT (couleur_cheveux),        "changed", G_CALLBACK (modif_c), (gpointer) tparam);

       Box_= gtk_frame_new("Couleur yeux");
       event_= gtk_event_box_new();
       color.pixel = 32;
       color.red = 55000;
       color.green = 55000;
       color.blue = 40000;
       gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
       gtk_container_add (GTK_CONTAINER (event_), Box_);
       gtk_box_pack_start (GTK_BOX (pVBox), event_, TRUE,TRUE, 0);
       couleur_yeux=gtk_entry_new();
       gtk_container_add (GTK_CONTAINER (Box_), couleur_yeux);
       g_signal_connect (G_OBJECT (couleur_yeux),        "changed", G_CALLBACK (modif_c), (gpointer) tparam);

       Box_= gtk_frame_new("Couleur peau");
       event_= gtk_event_box_new();
       color.pixel = 32;
       color.red = 55000;
       color.green = 55000;
       color.blue = 40000;
       gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
       gtk_container_add (GTK_CONTAINER (event_), Box_);
       gtk_box_pack_start (GTK_BOX (pVBox), event_, TRUE,TRUE, 0);
       couleur_peau=gtk_entry_new();
       gtk_container_add (GTK_CONTAINER (Box_), couleur_peau);
       g_signal_connect (G_OBJECT (couleur_peau),        "changed", G_CALLBACK (modif_c), (gpointer) tparam);

       Box_= gtk_frame_new("Classe sociale");
       event_= gtk_event_box_new();
       color.pixel = 32;
       color.red = 55000;
       color.green = 60000;
       color.blue = 40000;
       gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
       gtk_container_add (GTK_CONTAINER (event_), Box_);
       gtk_box_pack_start (GTK_BOX (pVBox), event_, TRUE,TRUE, 0);
       classe_sociale=gtk_entry_new();
       gtk_container_add (GTK_CONTAINER (Box_), classe_sociale);
       g_signal_connect (G_OBJECT (classe_sociale),        "changed", G_CALLBACK (modif_c), (gpointer) tparam);

       onglet2=gtk_vbox_new(FALSE, 6);
       gtk_box_pack_start (GTK_BOX (onglet1), onglet2, FALSE, FALSE, 1);

       /* Les compétances de voleurs */
       Box_ = gtk_frame_new("Compétences de voleurs");
       event_= gtk_event_box_new();
       color.pixel = 32;
       color.red = 55000;
       color.green = 55000;
       color.blue = 55000;
       gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
       gtk_container_add (GTK_CONTAINER (event_), Box_);
       //gtk_container_add(GTK_CONTAINER(pHBox_sort_fin) , event_);
       pVBox= gtk_vbox_new(FALSE, 6);
       gtk_container_add(GTK_CONTAINER(onglet2) , event_);


       table_vol=gtk_table_new(6,13,TRUE);
       gtk_container_add(GTK_CONTAINER(Box_) , table_vol);
        car_vol=(GtkWidget **)malloc(8*sizeof(GtkWidget *));
        for(i=0;i<8;i++)
        {
            label=gtk_label_new(NULL);
            sprintf(ch,"<span size=\"8500\">%s</span>",nom_fac_voleur[i]);
            gtk_label_set_markup (GTK_LABEL(label),ch);
            gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_LEFT);
            gtk_table_attach(GTK_TABLE(table_vol), label,
                i/2*3,i/2*3+4,  (i%2)*2, (i%2)*2+1,
                GTK_FILL , GTK_FILL,
                0, 0);
           car_vol[i]=gtk_spin_button_new_with_range(0, 999, 1);
           gtk_spin_button_set_value(GTK_SPIN_BUTTON(car_vol[i]),((unsigned short **)param)[C_VOLEUR][i]);
           gtk_table_attach(GTK_TABLE(table_vol), car_vol[i],
                i/2*3+1,i/2*3+3,  (i%2)*2+1, (i%2)*2+2,
                GTK_EXPAND | GTK_FILL, GTK_EXPAND,
                0, 0);
           gtk_spin_button_set_value(GTK_SPIN_BUTTON(car_vol[i]),((unsigned short **)param)[C_VOLEUR][i]);
           g_signal_connect (G_OBJECT (car_vol[i]), "value_changed", G_CALLBACK (compt_vol2), (gpointer) tparam);
        }
        label_vol2=gtk_label_new(NULL);
        gtk_label_set_markup (GTK_LABEL(label_vol2),"Validité ?");
        gtk_label_set_justify(GTK_LABEL(label_vol2),GTK_JUSTIFY_CENTER);
          gtk_table_attach(GTK_TABLE(table_vol), label_vol2,
                2,13,4,6,
                GTK_EXPAND , GTK_EXPAND,
                0, 0);
        bouton_vol1=gtk_button_new_with_label("ADD1\nRôdeur");
        g_signal_connect (G_OBJECT (bouton_vol1), "clicked", G_CALLBACK (initialise_vol), (gpointer) tparam);
          gtk_table_attach(GTK_TABLE(table_vol), bouton_vol1,
                0,2,4,6,
                GTK_EXPAND , GTK_EXPAND,
                0, 0);

       pHBox= gtk_hbox_new(FALSE, 6);
       gtk_container_add(GTK_CONTAINER(onglet2) ,pHBox);

       pHBox_sort_fin= gtk_hbox_new(FALSE, 6);
       gtk_box_pack_start (GTK_BOX (pHBox), pHBox_sort_fin, TRUE,TRUE, 0);

       Box_ = gtk_frame_new("Dieu du Personnage");
       event_= gtk_event_box_new();
       color.pixel = 32;
       color.red = 65000;
       color.green = 65000;
       color.blue = 65000;
       gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
       gtk_container_add (GTK_CONTAINER (event_), Box_);
       gtk_container_add(GTK_CONTAINER(pHBox_sort_fin) , event_);
       pVBox= gtk_vbox_new(FALSE, 6);
       gtk_container_add(GTK_CONTAINER(Box_) , pVBox);

         label_pan=gtk_label_new ("\nPanthéon");
         gtk_label_set_justify(GTK_LABEL(label_pan),GTK_JUSTIFY_CENTER); /* centrer la ligne */
         gtk_box_pack_start (GTK_BOX (pVBox), label_pan, FALSE, FALSE, 1);

         node1=g_markup_dom_new(chemin_dieux(ch),NULL);
         p_cell = gtk_cell_renderer_text_new ();
         gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (p_combo_pantheon), p_cell, FALSE);
         gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (p_combo_pantheon),p_cell, "text", 0,NULL);
         gtk_list_store_append (p_model_pan, & iter);
         gtk_list_store_set (p_model_pan, & iter,0,"Aucun",-1);
         if (node1==NULL || (node=g_markup_dom_node (node1,"document"))==NULL || g_markup_dom_node (node,"pan")==NULL)
         {
                 event_ = gtk_message_dialog_new (NULL,GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_CLOSE,"Le fichier dieux.add\n ne correspond pas à un fichier xml de dieux");
                 gtk_dialog_run(GTK_DIALOG(event_));
                 gtk_widget_destroy(event_);
         }
         else
             for(i=1;i<node->fils;i++)
             {
              gtk_list_store_append (p_model_pan, & iter);
              gtk_list_store_set (p_model_pan, & iter,0, node->child[i].content->texte,-1);
             }
         gtk_box_pack_start (GTK_BOX (pVBox), p_combo_pantheon, FALSE, FALSE, 0);
         gtk_combo_box_set_active (GTK_COMBO_BOX (p_combo_pantheon),0);
         g_signal_connect (G_OBJECT (p_combo_pantheon), "changed", G_CALLBACK (verif_pan), (gpointer) tparam);

         label_dieu=gtk_label_new ("\nDieu");
         gtk_label_set_justify(GTK_LABEL(label_dieu),GTK_JUSTIFY_CENTER); /* centrer la ligne */
         gtk_box_pack_start (GTK_BOX (pVBox), label_dieu, FALSE, FALSE, 1);
         p_cell_dieu = gtk_cell_renderer_text_new ();
         gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (p_combo_dieu), p_cell_dieu, FALSE);
         gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (p_combo_dieu),p_cell_dieu, "text", 0,NULL);
         gtk_list_store_append (p_model_dieu, & iter);
         gtk_list_store_set (p_model_dieu, & iter,0,"Aucun",-1);
         gtk_combo_box_set_active (GTK_COMBO_BOX (p_combo_dieu),0);
         gtk_box_pack_start (GTK_BOX (pVBox), p_combo_dieu, FALSE, FALSE, 0);
         g_signal_connect (G_OBJECT (p_combo_dieu), "changed", G_CALLBACK (verif_dieu), (gpointer) tparam);
         g_markup_dom_free(node1);


       event_= gtk_event_box_new();
       color.pixel = 32;
       color.red = 60000;
       color.green = 50000;
       color.blue = 55000;
       gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
       gtk_box_pack_start (GTK_BOX (pHBox), event_, TRUE,TRUE, 0);

       pVBox= gtk_vbox_new(FALSE, 6);
       gtk_container_add (GTK_CONTAINER (event_), pVBox);


       for(i=0;i<MAX_ARMURE;i++)
       {
            gtk_list_store_append (p_model_armure, & iter);
            gtk_list_store_set (p_model_armure, & iter,0, armures[i].nom,-1);
       }
       p_cell_armure= gtk_cell_renderer_text_new ();

       Box_= gtk_frame_new("Armure n°1 / Magie");
       gtk_box_pack_start (GTK_BOX (pVBox), Box_, FALSE,TRUE, 0);
       mag_armure1=gtk_spin_button_new_with_range(-5, 5, 1);
       gtk_spin_button_set_value(GTK_SPIN_BUTTON(mag_armure1),((unsigned short *)param)[MAG_ARMURE1]);
       p_combo_armure1=gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model_armure));
       pHBox_armure = gtk_hbox_new(FALSE, 6); /* FALSE : limite la taille des boutons */
       gtk_container_add (GTK_CONTAINER (Box_), pHBox_armure);
       gtk_box_pack_start (GTK_BOX (pHBox_armure), p_combo_armure1, FALSE,FALSE, 0);
       gtk_box_pack_start (GTK_BOX (pHBox_armure), mag_armure1, TRUE,TRUE, 0);
       gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (p_combo_armure1), p_cell_armure, FALSE);
       gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (p_combo_armure1),p_cell_armure, "text", 0,NULL);       //p_cell_armure= gtk_cell_renderer_text_new ();
       g_signal_connect (G_OBJECT (p_combo_armure1),        "changed", G_CALLBACK (modif_c), (gpointer) tparam);
       g_signal_connect (G_OBJECT (mag_armure1),      "value_changed", G_CALLBACK (modif_c), (gpointer) tparam);

       Box_= gtk_frame_new("Armure n°2 / Magie");
       gtk_box_pack_start (GTK_BOX (pVBox), Box_, FALSE,TRUE, 0);
       mag_armure2=gtk_spin_button_new_with_range(-5, 5, 1);
       gtk_spin_button_set_value(GTK_SPIN_BUTTON(mag_armure2),((unsigned short *)param)[MAG_ARMURE1]);
       p_combo_armure2=gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model_armure));
       pHBox_armure = gtk_hbox_new(FALSE, 6); /* FALSE : limite la taille des boutons */
       gtk_container_add (GTK_CONTAINER (Box_), pHBox_armure);
       gtk_box_pack_start (GTK_BOX (pHBox_armure), p_combo_armure2, TRUE,TRUE, 0);
       gtk_box_pack_start (GTK_BOX (pHBox_armure), mag_armure2, TRUE,TRUE, 0);
       gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (p_combo_armure2), p_cell_armure, FALSE);
       gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (p_combo_armure2),p_cell_armure, "text", 0,NULL);
       g_signal_connect (G_OBJECT (p_combo_armure2),        "changed", G_CALLBACK (modif_c), (gpointer) tparam);
       g_signal_connect (G_OBJECT (mag_armure2),      "value_changed", G_CALLBACK (modif_c), (gpointer) tparam);

       Box_= gtk_frame_new("Bouclier / Magie");
       gtk_box_pack_start (GTK_BOX (pVBox), Box_, TRUE,TRUE, 0);
       pHBox_armure = gtk_hbox_new(FALSE, 6); /* FALSE : limite la taille des boutons */
       gtk_container_add (GTK_CONTAINER (Box_), pHBox_armure);
       bouclier = gtk_check_button_new_with_label ("Présent");
       mag_bouclier=gtk_spin_button_new_with_range(-5,5, 1);
       gtk_box_pack_start (GTK_BOX (pHBox_armure), bouclier, TRUE,TRUE, 0);
       gtk_box_pack_start (GTK_BOX (pHBox_armure), mag_bouclier, TRUE,TRUE, 0);
       g_signal_connect (G_OBJECT (bouclier),        "clicked", G_CALLBACK (modif_c), (gpointer) tparam);
       g_signal_connect (G_OBJECT (mag_bouclier),      "value_changed", G_CALLBACK (modif_c), (gpointer) tparam);


       pHBox=gtk_hbox_new(FALSE, 6);
       gtk_box_pack_start (GTK_BOX (pVBox), pHBox, TRUE,TRUE, 0);

       Box_= gtk_frame_new("Bague de protection");
       gtk_box_pack_start (GTK_BOX (pHBox), Box_, TRUE,TRUE, 0);
       bonus_AC=gtk_spin_button_new_with_range(-5,5, 1);
       gtk_container_add (GTK_CONTAINER (Box_), bonus_AC);
       g_signal_connect (G_OBJECT (bonus_AC),      "value_changed", G_CALLBACK (modif_c), (gpointer) tparam);


       Box_ = gtk_frame_new("Alignement");
       event_= gtk_event_box_new();
       color.pixel = 32;
       color.red = 55000;
       color.green = 35000;
       color.blue = 5000;
       gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
       gtk_container_add (GTK_CONTAINER (event_), Box_);
       //gtk_container_add(GTK_CONTAINER(pHBox_sort_fin) , event_);
       gtk_container_add(GTK_CONTAINER(pHBox) , event_);

       table_vol=gtk_table_new(4,4,TRUE);
       gtk_container_add(GTK_CONTAINER(Box_) , table_vol);
        label=gtk_label_new(NULL);
        gtk_label_set_markup (GTK_LABEL(label),"L");
        gtk_table_attach(GTK_TABLE(table_vol), label,
            1,2,0,1,
            GTK_FILL , GTK_FILL,
            0, 0);
        label=gtk_label_new(NULL);
        gtk_label_set_markup (GTK_LABEL(label),"N");
        gtk_table_attach(GTK_TABLE(table_vol), label,
            2,3,0,1,
            GTK_FILL , GTK_FILL,
            0, 0);
        label=gtk_label_new(NULL);
        gtk_label_set_markup (GTK_LABEL(label),"C");
        gtk_table_attach(GTK_TABLE(table_vol), label,
            3,4,0,1,
            GTK_FILL , GTK_FILL,
            0, 0);
        label=gtk_label_new(NULL);
        gtk_label_set_markup (GTK_LABEL(label),"B");
        gtk_table_attach(GTK_TABLE(table_vol), label,
            0,1,1,2,
            GTK_FILL , GTK_FILL,
            0, 0);
        label=gtk_label_new(NULL);
        gtk_label_set_markup (GTK_LABEL(label),"N");
        gtk_table_attach(GTK_TABLE(table_vol), label,
            0,1,2,3,
            GTK_FILL , GTK_FILL,
            0, 0);
        label=gtk_label_new(NULL);
        gtk_label_set_markup (GTK_LABEL(label),"M");
        gtk_table_attach(GTK_TABLE(table_vol), label,
            0,1,3,4,
            GTK_FILL , GTK_FILL,
            0, 0);
       alignement=(GtkWidget ** )malloc(9*sizeof(GtkWidget *));
       alignement[0] = gtk_radio_button_new(NULL);
        gtk_table_attach(GTK_TABLE(table_vol), alignement[0],
            1,2,1,2,
            GTK_FILL , GTK_FILL,
            0, 0);
       for(i=1;i<9;i++)
       {
            alignement[i] = gtk_radio_button_new_from_widget(GTK_RADIO_BUTTON(alignement[0]));
            gtk_table_attach(GTK_TABLE(table_vol), alignement[i],
                1+i%3,2+i%3,1+i/3,2+i/3,
                GTK_FILL , GTK_FILL,
                0, 0);
            g_signal_connect (G_OBJECT (alignement[i]), "clicked", G_CALLBACK (verif_aligt), (gpointer) tparam);
       }

     /* le troisième onglet */
     onglet2=gtk_vbox_new(FALSE, 6);
     label_onglet2=gtk_label_new("Magicien");
     gtk_notebook_append_page(GTK_NOTEBOOK(onglet_maitre), onglet2, label_onglet2);
      onglet_mag=gtk_notebook_new();
      gtk_box_pack_start(GTK_BOX(onglet2), onglet_mag, TRUE, TRUE, 0);
      gtk_notebook_set_tab_pos(GTK_NOTEBOOK(onglet_mag), GTK_POS_BOTTOM);
      /* Ajout des boutons de navigation */
      gtk_notebook_set_scrollable(GTK_NOTEBOOK(onglet_mag), TRUE);

      sort_mag=(GtkWidget **** )malloc(9*sizeof(GtkWidget ***));
      nb_sort_mag=(unsigned short *)malloc(9*sizeof(unsigned short));
      for(i=0;i<9;i++)
       nb_sort_mag[i]=0;
      for(i=0;i<NB_SORT_MAG;i++)
       nb_sort_mag[sortileges_mag[i].niveau-1]++;

      for(i=0;i<9;i++)
      {
           sort_mag[i]=(GtkWidget *** )malloc(nb_sort_mag[i]*sizeof(GtkWidget **));

           onglet2=gtk_scrolled_window_new (NULL, NULL);
           sprintf(ch,"niv %hu",i+1);
           label_onglet2=gtk_label_new(ch);
           gtk_notebook_append_page(GTK_NOTEBOOK(onglet_mag), onglet2, label_onglet2);
           table_vol=gtk_table_new(nb_sort_mag[i]+2,8,TRUE);
           gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(onglet2) ,GTK_WIDGET(table_vol));
           gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (onglet2), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

           b_initialise = gtk_button_new_from_stock (GTK_STOCK_CLEAR); /*GTK_STOCK_DIALOG_INFO);*/
           g_signal_connect (G_OBJECT (b_initialise), "clicked", G_CALLBACK (init_mag), (gpointer) tparam);
           gtk_table_attach(GTK_TABLE(table_vol), b_initialise,
                    0,4,0,2,GTK_EXPAND , GTK_EXPAND,0, 0);

           label_onglet2=gtk_label_new(NULL);
           gtk_label_set_markup (GTK_LABEL(label_onglet2),"<span size=\"7500\">Compris</span>");
           gtk_label_set_justify(GTK_LABEL(label_onglet2),GTK_JUSTIFY_CENTER);
           gtk_table_attach(GTK_TABLE(table_vol), label_onglet2,
                    4,5,0,2,GTK_EXPAND , GTK_EXPAND,0, 0);
           label_onglet2=gtk_label_new(NULL);
           gtk_label_set_markup (GTK_LABEL(label_onglet2),"<span size=\"7500\">Pas\ncompris</span>");
           gtk_label_set_justify(GTK_LABEL(label_onglet2),GTK_JUSTIFY_CENTER);
           gtk_table_attach(GTK_TABLE(table_vol), label_onglet2,
                    5,6,0,2,GTK_EXPAND , GTK_EXPAND,0, 0);
           label_onglet2=gtk_label_new(NULL);
           gtk_label_set_markup (GTK_LABEL(label_onglet2),"<span size=\"7500\">Dans le livre\npas regardé</span>");
           gtk_label_set_justify(GTK_LABEL(label_onglet2),GTK_JUSTIFY_CENTER);
           gtk_table_attach(GTK_TABLE(table_vol), label_onglet2,
                    6,7,0,2,GTK_EXPAND , GTK_EXPAND,0, 0);
           label_onglet2=gtk_label_new(NULL);
           gtk_label_set_markup (GTK_LABEL(label_onglet2),"<span size=\"7500\">Pas dans\nle livre</span>");
           gtk_label_set_justify(GTK_LABEL(label_onglet2),GTK_JUSTIFY_CENTER);
           gtk_table_attach(GTK_TABLE(table_vol), label_onglet2,
                    7,8,0,2,GTK_EXPAND , GTK_EXPAND,0, 0);
           for(j=0,k=0;j<nb_sort_mag[i];j++,k++)
           {
               while (sortileges_mag[k].niveau!=i+1) k++;
               sort_mag[i][j]=(GtkWidget ** )malloc(4*sizeof(GtkWidget *));
               label_onglet2=gtk_label_new(sortileges_mag[k].nom);
               gtk_label_set_justify(GTK_LABEL(label_onglet2),GTK_JUSTIFY_CENTER);
               gtk_table_attach(GTK_TABLE(table_vol), label_onglet2,
                        0,5,2+j,3+j,GTK_EXPAND , GTK_EXPAND,0, 0);
               sort_mag[i][j][0] = gtk_radio_button_new(NULL);
               sort_mag[i][j][1] = gtk_radio_button_new_from_widget(GTK_RADIO_BUTTON(sort_mag[i][j][0]));
               sort_mag[i][j][2] = gtk_radio_button_new_from_widget(GTK_RADIO_BUTTON(sort_mag[i][j][0]));
               sort_mag[i][j][3] = gtk_radio_button_new_from_widget(GTK_RADIO_BUTTON(sort_mag[i][j][0]));
               gtk_table_attach(GTK_TABLE(table_vol), sort_mag[i][j][1],
                        4,5,2+j,3+j,GTK_EXPAND , GTK_EXPAND,0, 0);
               gtk_table_attach(GTK_TABLE(table_vol), sort_mag[i][j][2],
                        5,6,2+j,3+j,GTK_EXPAND , GTK_EXPAND,0, 0);
               gtk_table_attach(GTK_TABLE(table_vol), sort_mag[i][j][3],
                        6,7,2+j,3+j,GTK_EXPAND , GTK_EXPAND,0, 0);
               gtk_table_attach(GTK_TABLE(table_vol), sort_mag[i][j][0],
                        7,8,2+j,3+j,GTK_EXPAND , GTK_EXPAND,0, 0);
               g_signal_connect (G_OBJECT (sort_mag[i][j][0]), "clicked", G_CALLBACK (modif_c), (gpointer) tparam);
               g_signal_connect (G_OBJECT (sort_mag[i][j][1]), "clicked", G_CALLBACK (modif_c), (gpointer) tparam);
               g_signal_connect (G_OBJECT (sort_mag[i][j][2]), "clicked", G_CALLBACK (modif_c), (gpointer) tparam);
               g_signal_connect (G_OBJECT (sort_mag[i][j][3]), "clicked", G_CALLBACK (modif_c), (gpointer) tparam);
           }
       }

     /* le quatrième onglet */
     label_onglet2=gtk_label_new("Taille/Poids");
     table_vol=gtk_table_new(14,20,TRUE);
     gtk_notebook_append_page(GTK_NOTEBOOK(onglet_maitre), table_vol, label_onglet2);
     label_onglet2=gtk_label_new("Variation de la taille");
     gtk_label_set_justify(GTK_LABEL(label_onglet2),GTK_JUSTIFY_CENTER);
     gtk_table_attach(GTK_TABLE(table_vol), label_onglet2,
            0,10,0,1,GTK_EXPAND , GTK_EXPAND,0, 0);
     label_onglet2=gtk_label_new("Variation du poids");
     gtk_label_set_justify(GTK_LABEL(label_onglet2),GTK_JUSTIFY_CENTER);
     gtk_table_attach(GTK_TABLE(table_vol), label_onglet2,
            10,20,0,1,GTK_EXPAND , GTK_EXPAND,0, 0);
     d_taille=(GtkWidget **)malloc(9*sizeof(GtkWidget *));
     d_poids=(GtkWidget **)malloc(9*sizeof(GtkWidget *));
     if (((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.nom!=NULL)
      j=compare_sans_casse(((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.nom,"humain")==0?4:3;
     else j=3;

     for (i=0;i<9;i++)
     {
         if (i==0)
         {
             sprintf(ch,"000-%03hu",v_poids_taille[0]-1);
             d_taille[0]=gtk_radio_button_new_with_label(NULL,ch);
             d_poids[0]=gtk_radio_button_new_with_label(NULL,ch);
         }
         else
         {
             sprintf(ch,"%03hu-%03hu",v_poids_taille[i-1],v_poids_taille[i]-1);
             d_taille[i]=gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(d_taille[0]),ch);
             d_poids[i]=gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(d_poids[0]),ch);
         }
         gtk_table_attach(GTK_TABLE(table_vol),d_taille[i],
                0,3,1+i,2+i,GTK_EXPAND , GTK_EXPAND,0, 0);
         gtk_table_attach(GTK_TABLE(table_vol),d_poids[i],
                10,13,1+i,2+i,GTK_EXPAND , GTK_EXPAND,0, 0);
     }
     dv_taille=gtk_spin_button_new_with_range(0,0,1);
     dv_poids=gtk_spin_button_new_with_range(0,0,1);
     gtk_table_attach(GTK_TABLE(table_vol),dv_taille,
            5,9,1,2,GTK_EXPAND , GTK_EXPAND,0, 0);
     gtk_table_attach(GTK_TABLE(table_vol),dv_poids,
            15,19,1,2,GTK_EXPAND , GTK_EXPAND,0, 0);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(d_taille[4]),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(d_poids[4]),TRUE);
     for (i=0;i<9;i++)
     { /* la procédure fait appel à tous les boutons : même ceux qui ne sont peut-être pas encore défini si je le fais dans la première boucle */
         g_signal_connect (G_OBJECT (d_taille[i]), "clicked", G_CALLBACK (adapte_taille), (gpointer) tparam);
         g_signal_connect (G_OBJECT (d_poids[i]), "clicked", G_CALLBACK (adapte_poids), (gpointer) tparam);
     }

     Box_= gtk_frame_new("Taille");
     event_= gtk_event_box_new();
     color.pixel = 32;
     color.red = 65000;
     color.green = 55000;
     color.blue = 0;
     gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
     gtk_container_add (GTK_CONTAINER (event_), Box_);
     gtk_table_attach(GTK_TABLE(table_vol),event_,
            4,9,8,10,GTK_FILL , GTK_FILL,0, 0);
     c_taille=gtk_spin_button_new_with_range(0,999,1);
     gtk_container_add (GTK_CONTAINER (Box_), c_taille);
     g_signal_connect (G_OBJECT (c_taille),      "value_changed", G_CALLBACK (modif_c), (gpointer) tparam);

     Box_= gtk_frame_new("Poids");
     event_= gtk_event_box_new();
     color.pixel = 32;
     color.red = 50000;
     color.green = 65000;
     color.blue = 0;
     gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
     gtk_container_add (GTK_CONTAINER (event_), Box_);
     gtk_table_attach(GTK_TABLE(table_vol),event_,
            14,19,8,10,GTK_FILL , GTK_FILL,0, 0);
     c_poids=gtk_spin_button_new_with_range(0,999,1);
     gtk_container_add (GTK_CONTAINER (Box_), c_poids);
     g_signal_connect (G_OBJECT (c_poids),      "value_changed", G_CALLBACK (modif_c), (gpointer) tparam);

     b_valide = gtk_button_new_with_label ("Tirage");
     chemin=chemin_exe();
     sprintf(ch,"%s%c3d6_ico.png",chemin,SEPARATEUR);
     free(chemin);
     gtk_button_set_image(GTK_BUTTON(b_valide),gtk_image_new_from_file(ch));
     g_signal_connect (G_OBJECT (b_valide), "clicked", G_CALLBACK (tire_taille_poids),(gpointer) tparam);
     gtk_table_attach(GTK_TABLE(table_vol),b_valide,
            0,4,10,13,GTK_EXPAND , GTK_EXPAND,0, 0);
     b_valide = gtk_button_new_with_label ("Calcul");
     chemin=chemin_exe();
     sprintf(ch,"%s%ccalc_ico.png",chemin,SEPARATEUR);
     free(chemin);
     gtk_button_set_image(GTK_BUTTON(b_valide),gtk_image_new_from_file(ch));
     g_signal_connect (G_OBJECT (b_valide), "clicked", G_CALLBACK (calc_taille_poids), (gpointer) tparam);
     gtk_table_attach(GTK_TABLE(table_vol),b_valide,
            16,20,10,13,GTK_EXPAND , GTK_EXPAND,0, 0);

     label_onglet2=gtk_label_new("Pour plus d'information regarder http://troumad.org/Mes_regles/Poids_Taille.html");
     gtk_label_set_justify(GTK_LABEL(label_onglet2),GTK_JUSTIFY_CENTER);
     gtk_table_attach(GTK_TABLE(table_vol), label_onglet2,
            0,20,13,14,GTK_EXPAND , GTK_EXPAND,0, 0);
     label_taille=gtk_label_new("Taille pour la race\n en pied");
     gtk_label_set_justify(GTK_LABEL(label_onglet2),GTK_JUSTIFY_CENTER);
     gtk_table_attach(GTK_TABLE(table_vol), label_taille,
            3,10,4,5,GTK_EXPAND , GTK_EXPAND,0, 0);
     d_taille_race=gtk_spin_button_new_with_range(0,0,1);
     gtk_table_attach(GTK_TABLE(table_vol),d_taille_race,
            5,9,5,6,GTK_EXPAND , GTK_EXPAND,0, 0);
     label_taille=gtk_label_new("<-Tirage aléatoire et calcul du poids et de la taille\nCalcul du poids et de la taille en fonction des choix ->");
     gtk_label_set_justify(GTK_LABEL(label_onglet2),GTK_JUSTIFY_CENTER);
     gtk_table_attach(GTK_TABLE(table_vol), label_taille,
            4,16,10,13,GTK_EXPAND , GTK_EXPAND,0, 0);


     /* le cinquième onglet */
     texte=gtk_text_view_new();
     onglet2=gtk_scrolled_window_new (NULL, NULL);
     label_onglet2=gtk_label_new("Notes");
     gtk_notebook_append_page(GTK_NOTEBOOK(onglet_maitre), onglet2, label_onglet2);
     gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(onglet2), texte);
     gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (onglet2), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
     p_text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (texte));
     g_signal_connect (G_OBJECT (p_text_buffer),      "changed", G_CALLBACK (modif_c), (gpointer) tparam);


   /* les boutons de contrôle en dessous des onglets */
   pVBox_fin= gtk_hbox_new(FALSE, 6);
   gtk_box_pack_start (GTK_BOX(pVBoxOnglets) , pVBox_fin,FALSE,TRUE,1);

     /* les boutons de contrôle */
     b_valide = gtk_button_new_from_stock (GTK_STOCK_APPLY); /*GTK_STOCK_DIALOG_INFO);*/
     g_signal_connect (G_OBJECT (b_valide), "clicked", G_CALLBACK (valide_c), (gpointer) tparam);
     gtk_box_pack_start (GTK_BOX (pVBox_fin), b_valide, TRUE, TRUE, 1);

     b_initialise = gtk_button_new_from_stock (GTK_STOCK_GO_BACK); /*GTK_STOCK_DIALOG_INFO);*/
     g_signal_connect (G_OBJECT (b_initialise), "clicked", G_CALLBACK (initialise_c), (gpointer) tparam);
     gtk_box_pack_start (GTK_BOX (pVBox_fin), b_initialise, TRUE, TRUE, 1);

     b_annule = gtk_button_new_from_stock (GTK_STOCK_CLOSE); /*GTK_STOCK_DIALOG_INFO);*/
     g_signal_connect (G_OBJECT (b_annule), "clicked", G_CALLBACK (annule_c), (gpointer) tparam);
     gtk_box_pack_start (GTK_BOX (pVBox_fin), b_annule, TRUE, TRUE, 1);


  tparam[ 0]=((gpointer*)param); /* pointeur mémorisation caractéristique */
  tparam[ 1]=(gpointer)caract; //
  tparam[ 2]=(gpointer)entree; //
  tparam[ 3]=(gpointer)pWindow; //
  tparam[ 4]=((gpointer*)param)+FILS; /* signaler la disparition de la fenêtre au père */
  tparam[ 5]=(gpointer)p_combo; //
  tparam[ 6]=(gpointer)p_combo_race; //
  tparam[ 7]=(gpointer)p_combo_sexe; //

  tparam[ 8]=(gpointer)niv_classe;
  tparam[ 9]=(gpointer)nb_case_metier;
  tparam[10]=(gpointer)pHBox_classes;
  tparam[11]=(gpointer)pVBox_classes; /* // : à ne pas free à la fin */
  tparam[12]=(gpointer)p_model_classe; //
  tparam[13]=(gpointer)p_combo_classe;
  tparam[34]=(gpointer)event_classes; //
  tparam[35]=(gpointer)xp_classe;

  tparam[14]=(gpointer)niv_armes;
  tparam[15]=(gpointer)nb_case_armes;
  tparam[16]=(gpointer)pHBox_armes;
  tparam[17]=(gpointer)pVBox_armes; //
  tparam[18]=(gpointer)p_model_armes; //
  tparam[19]=(gpointer)p_combo_armes;
  tparam[32]=(gpointer)label_armes; //
  tparam[33]=(gpointer)p_cell_armes;
  tparam[41]=(gpointer)mag_armes;

  tparam[20]=(gpointer)niv_comp;
  tparam[21]=(gpointer)nb_case_comp;
  tparam[22]=(gpointer)pHBox_comp;
  tparam[23]=(gpointer)pVBox_comp; //
  tparam[24]=(gpointer)p_model_comp; //
  tparam[25]=(gpointer)p_combo_comp;
  tparam[31]=(gpointer)label_compt; //

  tparam[26]=(gpointer)niv_pdv;
  tparam[27]=(gpointer)nb_case_pdv;
  tparam[28]=(gpointer)pVBox_PDV; //
  tparam[29]=(gpointer)car_vol;
  tparam[30]=(gpointer)label_vol2; //

  tparam[36]=(gpointer)p_combo_pantheon; //
  tparam[37]=(gpointer)p_combo_dieu; //
  tparam[38]=(gpointer)p_model_dieu; //

  tparam[39]=(gpointer)texte; //

  tparam[40]=(gpointer)nb_sort_mag;
  tparam[56]=(gpointer)sort_mag; // tableau à 3D 9xNB_SORT_MAGx4 de pointeurs...

  tparam[42]=(gpointer)d_taille; /* plus de tableau à free à la fin */
  tparam[43]=(gpointer)d_poids;
  tparam[44]=(gpointer)dv_taille;
  tparam[45]=(gpointer)dv_poids;
  tparam[46]=(gpointer)c_taille;
  tparam[47]=(gpointer)c_poids;
  tparam[48]=(gpointer)d_taille_race;
  tparam[49]=(gpointer)label_taille;
  tparam[50]=(gpointer)nom_perso;
  tparam[51]=(gpointer)nom_joueur;
  tparam[52]=(gpointer)classe_sociale;
  tparam[53]=(gpointer)couleur_peau;
  tparam[54]=(gpointer)couleur_cheveux;
  tparam[55]=(gpointer)couleur_yeux;
  tparam[57]=(gpointer)age;
  tparam[58]=(gpointer)p_combo_armure1;
  tparam[59]=(gpointer)mag_armure1;
  tparam[60]=(gpointer)p_combo_armure2;
  tparam[61]=(gpointer)mag_armure2;
  tparam[62]=(gpointer)bouclier;
  tparam[63]=(gpointer)mag_bouclier;
  tparam[64]=(gpointer)bonus_AC;
  tparam[65]=(gpointer)m_modif;

  tparam[66]=(gpointer)alignement;

//  GtkWidget * nom_perso, * nom_joueur, * classe_sociale, * couleur_peau, * couleur_cheveux, *couleur_yeux;

  initialise_c(NULL,tparam);
  verif_pdv(NULL,tparam);
  verif_compt(NULL,tparam);
  verif_armes(NULL,tparam);
  compt_vol2(NULL,tparam);
  init_taille(tparam);
  gtk_widget_show_all (pWindow);

  (void)wid;
  return (gpointer)tparam;
}

