/*
    Génération de feuille de personnage complète AD&D 1 et 2
    Génération aléatoire de personnage

    Copyright (C) 2011 Bernard SIAUD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#if defined(__FreeBSD__)
#include <stdlib.h>
#else
#include <malloc.h>
/*#ifdef WIN32
#include <windows.h>
#endif*/
#endif


#include <unistd.h>
#include "include.h"

void cb_fin(GtkWidget *p_widget, gpointer param)
{

  free(param);
  gtk_main_quit();

 /* parametres inutilises */
 (void)p_widget;
}

void fin_feuille(GtkWidget *p_widget, gpointer param)
{

 /* parametres inutilises */
 (void)p_widget;
 (void)param;
}


void fin_modif_sphere(GtkWidget *p_widget, gpointer param)
{
  GtkWidget *p_dialog = NULL;

  if (((unsigned short **)param)[6][0]==1)
  {
    p_dialog =  gtk_message_dialog_new (GTK_WINDOW(((GtkWindow **)param)[FENETRE]),GTK_DIALOG_MODAL,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,"Sauvegarder les modifications\ndu dieu ?");
    switch(gtk_dialog_run(GTK_DIALOG(p_dialog)))
    {
        case GTK_RESPONSE_NO:
            gtk_widget_destroy(p_dialog);
            break ;
        default :
            gtk_widget_destroy(p_dialog);
            sphere_nouv(NULL, param);
            break;
    }
  }

 if (((GtkWidget **)param)[3]) free(((GtkWidget **)param)[3]);
 free(param);

 /* parametres inutilises */
 (void)p_widget;
}

void fin_groupe(GtkWidget *p_widget, gpointer param)
{
 struct_groupe * gr, *gr1;
 char ch[LONG];
 if (   ((unsigned short **)param)[5][0]==1)
 { /* proposition de sauvegarde */

 }
 gr=((struct_groupe **)param)[4];
 while (gr!=NULL)
 {
     if (gr->ouvert==1)
        gtk_widget_destroy(gr->fils);
    free(gr->fichier[0]);
    free(gr->fichier[1]);
    gr1=gr;
    gr=gr->suiv;
    free(gr1);
 }
 gtk_widget_destroy(((GtkWidget**)param)[0]);

 sprintf(ch,"%s%c%s.grp.lock",((char **)param)[1],SEPARATEUR,((char **)param)[2]);
 //#ifdef __linux__
 if (remove(ch)!=0)
  perror(ch);
 /*#else
 DeleteFile(ch);
 #endif*/

 free(param);

 /* parametres inutilises */
 (void)p_widget;
}

void fin_perso(GtkWidget *p_widget, gpointer param)
{
 GtkWidget *p_dialog = NULL;
 char ch[LONG];
 unsigned short i;

 if (((GtkWidget **)param)[FILS]) gtk_widget_destroy(((GtkWidget **)param)[FILS]); // g_signal_emit_by_name(((GtkWidget **)param)[FILS],"destroy");
 if (((unsigned short **)param)[MODIF][0]==1)
 {
    p_dialog =  gtk_message_dialog_new (GTK_WINDOW(((GtkWindow **)param)[FENETRE]),GTK_DIALOG_MODAL,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,"Sauvegarder les modifications\nde la fenêtre 'Résumé' ?");
    switch(gtk_dialog_run(GTK_DIALOG(p_dialog)))
    {
        case GTK_RESPONSE_NO:
            gtk_widget_destroy(p_dialog);
            break ;
        default :
            gtk_widget_destroy(p_dialog);
            sauvegarde_perso (NULL, param);
            break;
    }
 }
 sprintf(ch,"%s%c%s.pers.lock",((char **)param)[CHEMIN],SEPARATEUR,((char **)param)[NOM]);
 //#ifdef __linux__
 remove(ch);
 /*#else
 DeleteFile(ch);
 #endif*/
 for (i=0;i<MAX_TIRAGE;i++)
 {
        if (i!=4 && i!=7 && i!=8 && i!=METIER && i!=MENU) free(((void **)param)[i]);
 }

 free_metier(((liste_classe **)param)[METIER]);

 /* effacer dans param 9 à partir de param 7 */
 free(param);
 /* parametres inutilises */
 (void)p_widget;
}

void fin_modif_caract(GtkWidget *p_widget, gpointer param)
{
 GtkWidget *p_dialog = NULL;
 unsigned short i=0,j;

 if (((unsigned short **)param)[M_MODIF][0]==1)
 {
    p_dialog =  gtk_message_dialog_new (GTK_WINDOW(p_widget),GTK_DIALOG_MODAL,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,"Sauvegarder les modifications\nde la fenêtre 'modification' ?");
    switch(gtk_dialog_run(GTK_DIALOG(p_dialog)))
    {
        case GTK_RESPONSE_NO:
            gtk_widget_destroy(p_dialog);
            break ;
        default :
            gtk_widget_destroy(p_dialog);
            valide_c(NULL, param);
            break;
    }
 }

 *(((gpointer**)param)[4])=NULL; /* signaler au père que le fils est mort pour pouvoir en ouvrir un autre */
 free(*((void **)(param)+ 2));
 free(*((void **)(param)+ 8));
 free(*((void **)(param)+ 9));
 free(*((void **)(param)+10));
 free(*((void **)(param)+13));
 free(*((void **)(param)+35));
 free(*((void **)(param)+14));
 free(*((void **)(param)+15));
 free(*((void **)(param)+16));
 free(*((void **)(param)+19));
 free(*((void **)(param)+33));
 free(*((void **)(param)+41));
 free(*((void **)(param)+20));
 free(*((void **)(param)+21));
 free(*((void **)(param)+22));
 free(*((void **)(param)+25));
 free(*((void **)(param)+26));
 free(*((void **)(param)+27));
 free(*((void **)(param)+29));
 for (j=0;j<9;j++)
 {
     for (i=0;i<((unsigned short **)param)[M_NB_SORT_MAG][j];i++)
     {
         free (((void *****)param)[56][j][i]);
     }
     free (((void *****)param)[56][j]);
 }
 free(*((void **)(param)+40)); // M_NB_SORT_MAG vaut 40
 free(((void *****)param)[56]);

 free(param);

 (void)p_widget;
}
